<template>
  <div class="w-full md:max-w-md">
    <div class="flex flex-col items-center">
      <p class="text-xl font-medium">Protokoll erstellen</p>
    </div>
    <br />
    <form ref="form" class="flex flex-col gap-4 py-2" @submit.prevent="triggerCreate">
      <div>
        <label for="title">Titel</label>
        <input type="text" id="title" required autocomplete="false" />
      </div>
      <div>
        <label for="date">Datum</label>
        <input type="date" id="date" required />
      </div>
      <div class="flex flex-row gap-2">
        <button primary type="submit" :disabled="status == 'loading' || status?.status == 'success'">erstellen</button>
        <Spinner v-if="status == 'loading'" class="my-auto" />
        <SuccessCheckmark v-else-if="status?.status == 'success'" />
        <FailureXMark v-else-if="status?.status == 'failed'" />
      </div>
    </form>

    <div class="flex flex-row justify-end">
      <div class="flex flex-row gap-4 py-2">
        <button primary-outline @click="closeModal" :disabled="status == 'loading' || status?.status == 'success'">
          abbrechen
        </button>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { defineComponent } from "vue";
import { mapState, mapActions } from "pinia";
import { useModalStore } from "@/stores/modal";
import Spinner from "@/components/Spinner.vue";
import SuccessCheckmark from "@/components/SuccessCheckmark.vue";
import FailureXMark from "@/components/FailureXMark.vue";
import { useProtocolStore } from "@/stores/admin/protocol";
import type { CreateProtocolViewModel } from "@/viewmodels/admin/protocol.models";
</script>

<script lang="ts">
export default defineComponent({
  data() {
    return {
      status: null as null | "loading" | { status: "success" | "failed"; reason?: string },
      timeout: undefined as any,
    };
  },
  beforeUnmount() {
    try {
      clearTimeout(this.timeout);
    } catch (error) {}
  },
  methods: {
    ...mapActions(useModalStore, ["closeModal"]),
    ...mapActions(useProtocolStore, ["createProtocol"]),
    triggerCreate(e: any) {
      let formData = e.target.elements;
      let createProtocol: CreateProtocolViewModel = {
        title: formData.title.value,
        date: formData.date.value,
      };
      this.createProtocol(createProtocol)
        .then(() => {
          this.status = { status: "success" };
          this.timeout = setTimeout(() => {
            (this.$refs.form as HTMLFormElement).reset();
            this.closeModal();
          }, 1500);
        })
        .catch(() => {
          this.status = { status: "failed" };
        });
    },
  },
});
</script>
